#!/usr/bin/env python
# -*- coding: utf-8 -*-

# $Id: abs.py 82 2011-02-18 07:44:15Z kkumer $ 

"""Getting input of data for conference abstracts via HTML form.

kkumer@phy.hr 2003-03-26 
"""

PWD_PROTECTED = 1
execfile('../cgi_init.py')  # CGI initialization

## Getting db record into a dictionary a
a = get(cursor, uid)


## HTML form for additional fields request. 
add = Form(cgi=cfg['CGI_LINK']+"abstracts/additem.py",
         submit=Input(type="submit", value="Zatraži!"))
add.append(Input(type="hidden", name="pwd", value=pwd))

add.append(Heading(2, "Zahtjev za dodatna polja:"))
add.append("""<P>Ukoliko vam je trenutni broj polja za unos dostatan,
preskočite ovo i prijeđite na unošenje podataka.""")
t = TableLite()
t.append(TR(TD("Trebam dodatnih "), 
            TD(Select(data=map(str, range(10)),
                         selected="0",
                         name="addauthor", 
                         size=1)), 
            TD(" polja za unos autora.")))
t.append(TR(TD("Trebam dodatnih "), 
            TD(Select(data=map(str, range(10)),
                         selected="0",
                         name="addinst", 
                         size=1)), 
            TD(" polja za unos institucija.")))
t.append(TR(TD("Trebam dodatnih "), 
            TD(Select(data=map(str, range(10)),
                         selected="0",
                         name="addref", 
                         size=1)), 
            TD(" polja za unos literature.")))
add.append(t)
add.append("""<p>""")
## HTML form for data input

f = Form(cgi=cfg['CGI_LINK']+"abstracts/pdfgen.py",
         submit=Input(type="submit", value="Prijavi!"),
         reset=Input(type="reset", value="Vrati u prvobitno stanje"))
f.append(Input(type="hidden", name="pwd", value=pwd))


f.append(Heading(2, "Unos podataka"))

f.append("""<P>(Ukoliko su vam neka polja suvišna samo izbrišite
podatke u njima i ona će nestati nakon prijave.)""")

## Naslov
f.append(Heading(3, "Naslov:"))
f.append(Input(name="title", value=a['title'], size=70))

## Authors table
f.append(Heading(3, "Autori:"))
f.append("""(Sparite autore s odgovarajućim institucijama izborom
istog rednog broja institucije. Ime i prezime su obavezni, a e-mail
je opcija.)<P>""")
atable = TableLite()
for n in range(len(a['authors'])):
    # Each author gets a table row.
    arow = TR()
    author = Author(a['authors'][n])
    arow.append(TD("Ime:", Input(type="text",
                        name="authorname%s" % str(n+1), 
                        value=author.name,
                        size=8)))
    arow.append(TD("Prezime:", Input(type="text",
                           name="authorsurname%s" % str(n+1), 
                           value=author.surname,
                           size=12)))
    arow.append(TD("Email:", Input(type="text",
                        name="authoremail%s" % str(n+1), 
                        value=author.email,
                        size=18)))
    arow.append(TD("Institucija:",Select(data=map(str,
                                 range(1, len(a['institutions'])+1)),
                         selected=author.instid,
                         name="authorinstid%s" % (n+1), 
                         size=1)))
    atable.append(arow)
f.append(atable)

## Institutions table
f.append(Heading(3,"Institucije:"))
itable = TableLite()
for n in range(len(a['institutions'])):
    # Each institution gets a table row.
    irow = TR()
    irow.append(TD(Bold("[%s]" % str(n+1))))
    irow.append(TD(Input(type="text",
                           name="instname%s" % (n+1), 
                           value=a['institutions'][n][1],
                           size=60)))
    itable.append(irow)
f.append(itable)


## Body
f.append(Heading(3, "Sažetak:"))
f.append(Textarea(name="body", text=a['body'], rows=10, cols=80))

## References table
f.append(Heading(3,"Literatura:"))
rtable = TableLite()
for n in range(len(a['refs'])):
    # Each reference gets a table row.
    rrow = TR()
    rrow.append(TD(Bold("[%s]" % str(n+1))))
    rrow.append(TD(Input(type="text",
                           name="ref%s" % (n+1), 
                           value=a['refs'][n][1],
                           size=40)))
    rtable.append(rrow)
f.append(rtable)
f.append("""<p>""")

############################
## PACS
f.append(Heading(3, "Pripadajuće znanstveno područje:"))

f.append("""(Moguće je označiti više od jednog područja.)<BR>""")

pacslist = [
(["00"], "general", "Opća fizika"),
(["10"], "particle",  "Fizika elementarnih čestica i polja"),
(["20"], "nuclear", "Nuklearna fizika"),
(["30", "50"], "atomic", "Atomska i molekularna fizika, fizika plinova, plazmi i električnih izboja"),
(["40"], "classical", "Elektromagnetizam, optika, akustika, prijenos topline, klasična mehanika, dinamika fluida"),
(["60", "70"], "condensed", "Fizika kondenzirane tvari"),
(["80"], "interdisc", "Interdisciplinarna fizika i srodna područja znanosti i tehnologije"),
(["91-94"], "geo", "Geofizika"),
(["95-98"], "astro", "Astronomija i astrofizika"),
(["87"], "med_bio", "Medicinska fizika i biofizika"),
([], "primj", "Primjenjena fizika, uređaji, fizika u mjerenju"),
([], "edu", "Edukacijska fizika")
]

ptable = TableLite()
for field in pacslist:
    prow = TR()
    prow.append(TD(Input(type="checkbox",
                         name="pacs",
                         value=field[1],
                         checked=a['pacs'].split(',').count(field[1])
                )))
    opis = TD(field[2])
    for code in field[0]:
        opis.append(" ")
        #opis.append(Href(
        #             url='http://www.aip.org/pacs/pacs03/pacs03'+code[0]+'0.html',
        #             text = 'PACS '+code))
    prow.append(opis)
    ptable.append(prow)

f.append(ptable)


############################


## Generating HTML page with input form

# Producing title 
ttl = "Prijava sažetka - %s %s" % (uname, usurname)
ctype = Meta(equiv="Content-Type",
           content="text/html; charset=utf-8")

css = cfg['HTML_LINK']+"coonf.css"

doc = SimpleDocument(title=ttl, stylesheet=css)

# head
head, foot = web.extractHF()
doc.append(head)

# title
doc.append(Heading(1,ttl))

doc.append(Heading(3,"Uputstva"))
doc.append("""
Sažetak treba biti napisan na <B>hrvatskom jeziku</B>.
Prijava sažetka se obavlja u tri stupnja:
""")

list = OrderedList()
list.append("""Provjerite da li dolje na "Unosu podataka" imate na raspolaganju dovoljno upisnih
polja za autore, institucije i reference. Zatražite eventualna dodatna
polja i kliknite na "Zatraži!" 
<p>
Ako pak imate <i>višak</i> polja za unos, ista ostavite praznima tj.
izbrišite ih pa će nestati nakon prijave.
""")
list.append("""Unesite podatke. Ono što unesete bit će procesirano LaTeX
programom za obradu teksta, ali poznavanje LaTeX-a nije nužno za prijavu.
Jedino trebate imati na umu da
slijedeći znakovi imaju specijalnu funkciju i inače su 
<B>zabranjeni</B>: &nbsp; &nbsp; $, &, %%, #, _, ^, {, }, &#92 <BR>
Za složenije formatiranje teksta (grčka slova, formule), konzultirajte kratke
<A href="%slatex.html">LaTeX upute</A>.
<p>
Nakon unosa, kliknite na "Prijavi" i
dobit ćete potvrdu da su podaci (1) uspješno upisani u bazu podataka i
(2) da su uspješno složeni za tisak. 
<P>
Ako dođe do problema, poruka o grešci bi trebala biti dovoljno informativna.
Ako nije, obratite se za pomoć <A HREF="mailto:%s">emailom</A>.
             """ % (cfg['HTML_LINK'], cfg['ADMIN']))
list.append("""Sažetak složen za tisak možete provjeriti u
Adobe Acrobat-u i svakako to učinite. On <STRONG>obavezno</STRONG> mora 
stati na <STRONG>jednu</STRONG> stranicu. 
Proizvoljne naknadne korekcije, poput skraćivanja teksta, moguće je 
obaviti povratkom na ovu stranicu za unos što vam omogućuje višestruko
eksperimentiranje pri unosu svog sažetka. """)

doc.append(list)


doc.append(add)

doc.append(f)

# foot
doc.append(foot % today)
doc.write()

