#!/usr/bin/env python

# $Id: config.py 82 2011-02-18 07:44:15Z kkumer $ 

# This is configuration file with particularities of your machine,
# your database and your conference

# Typically, you want to change string 'conference' throughout this
# file into something descriptive of your conference

# TODO: Use ConfigParser module for this


cfg = {}

# =============   MODULE 'basic'  ==================

cfg['DEBUG'] = 1                      # debug
cfg['LOGDIR'] = '/tmp/conference/'         # create this dir!
cfg['EMAILING'] = 1                   # do we want to send confirmation
                               # messages to client and admin via email?

# [ ]  Database details

cfg['DB_NAME'] = 'conference' 
cfg['DB_USER'] = 'conferenceuser' 
cfg['DB_PASSWD'] = 'conferencepw'

cfg['UID_PASSWD'] = 'uidpswrd' # for URL encryption, must have 8 chars!

# [ ] Paths to HTML and CGI

cfg['HOSTNAME'] = 'yourserver.dot.com'         # hostname of server
cfg['DOCUMENT_ROOT'] = '/var/www/'   # as defined in httpd.conf
cfg['SCRIPT_ALIAS'] = '/usr/lib/cgi-bin/'   # as defined in httpd.conf
cfg['ROOT'] = 'conference/'  # path to our pages, both HTML and CGI

cfg['CGI_ROOT'] = cfg['SCRIPT_ALIAS'] + cfg['ROOT']     # absolute path to CGI
cfg['HTML_ROOT'] = cfg['DOCUMENT_ROOT'] + cfg['ROOT']   # absolute path to HTML
cfg['CGI_LINK'] = '/cgi-bin/' + cfg['ROOT']      # path to CGI to be used in hyperlinks
cfg['HTML_LINK'] = '/' + cfg['ROOT']             # path to HTML to be used in hyperlinks
# Same, but absolute links for sending in email:
cfg['ABS_CGI_LINK'] = 'http://' + cfg['HOSTNAME'] + '/cgi-bin/' + cfg['ROOT']
cfg['ABS_HTML_LINK'] = 'http://' + cfg['HOSTNAME'] + '/' + cfg['ROOT']

## Configuration file where data fields are described
cfg['REGISTER_CONF_FILE'] = cfg['CGI_ROOT'] + "register.conf"



# [ ] Email configuration

## FROM address (who appears to send email, usually conference address)
cfg['FROM_ADDR'] = "conference@email.com"

## administrator's address (to whom one copy of the email is sent)
cfg['ADMIN'] = "admin@email.com"

## .signature appended to every email
cfg['SIGNATURE'] = "Greatest Conference  ---   http://site.org/conference/"



# =============   MODULE 'web'  ==================

cfg['MODULE_WEB'] = 1       # To turn the module on put 1 here

# Name of the template file. It should be placed in HTML_ROOT
# so that CGI scripts can read it. File itself should contain:
#
# a) following three strings: @(TITLE)s, @(CONTENT)s, @(UPDATE)s
#    which are placeholders for actual data from publish_*.py
#    (dont forget 's' at the end: @(...)s)
#
# b) comments <!-- BEGIN head --> <!-- END head -->
#             <!-- BEGIN foot --> <!-- END foot -->
#    that delimit everything like in the example TEMPLATE.html

cfg['TEMPLATE_FILE'] = cfg['HTML_ROOT'] + 'TEMPLATE.html'
cfg['CSS_FILE'] = cfg['HTML_LINK'] + 'coonf.css'


# =============   MODULE 'abstracts'  ==================

cfg['MODULE_ABSTRACTS'] = 1       # To turn the module on put 1 here
                           # Don't forget to create database table!

# Path to pdflatex executable with options for batch running
cfg['PDFLATEX'] = '/usr/bin/pdflatex --interaction nonstopmode'
# Directory where .tex, .pdf and related files are saved
# Should be created beforehand and permissions should be 777.
cfg['PDFDIR'] = cfg['CGI_ROOT'] + 'abstracts/PDF/'


# =============   MODULE 'uploads'  ==================

cfg['MODULE_UPLOADS'] = 0       # To turn the module on put 1 here

# Directory where uploads are put.
# Should be created beforehand and permissions should be 777.
cfg['UPLOADSDIR'] = cfg['CGI_ROOT'] + 'uploads/FILES/'



