#!/usr/bin/env python
# -*- coding: utf-8 -*-

# $Id: upload.py 82 2011-02-18 07:44:15Z kkumer $ 

"""Handling file upload from home.py CGI script.
   Saves file in 'uploads' subdir with name ID-surname.ext.
   Then administrator should investigate the type of the file
     and set extension to .ppt, .pdf or something.

kkumer@phy.hr 2003-11-09 
"""

PWD_PROTECTED = 1
execfile('../cgi_init.py')

def die(message):
    doc.append(message)
    if cfg['DEBUG']: doc.append(str(form))
    doc.append(back)
    doc.append(foot % today)
    doc.write()
    sys.exit(1)

# Producing HTML report
ttl = "File upload confirmation - %s %s" % (uname, usurname)
ctype = Meta(equiv="Content-Type",
           content="text/html; charset=utf-8")

css = cfg['HTML_LINK'] + "coonf.css"

doc = SimpleDocument(title=ttl, stylesheet=css)

# head
# head
head, foot = extractHF()
doc.append(head)


## HTML form for going back
back = Form(cgi=cfg['CGI_LINK']+"home.py",
         submit=Input(type="submit", value="Back to your personal conference homepage"))
back.append(Input(type="hidden", name="pwd", value=pwd))

doc.append(Heading(2, ttl))

# First check that file is here
if not form.has_key("uploadedfile") or form["uploadedfile"].value == "":
    die("Nonexistent file! Try again:")

# Save the file
os.chdir(cfg['UPLOADSDIR'])

# Do we already have contribution from this ID?
# If yes - increase version number
version = 1
while os.path.isfile(os.path.join(cfg['UPLOADSDIR'],
     '%d-%s-v%d-%s' % (uid, usurname.encode('utf-8'), 
               version, form['uploadedfile'].filename) )):
    version += 1
filename = '%d-%s-v%d-%s' % (uid, usurname.encode('utf-8'), 
               version, form['uploadedfile'].filename)

try:
    f = open(filename, "wb")
    f.write(form["uploadedfile"].value)
    f.close()
except:
    die("Something went wrong. Try again or contact us.")

doc.append("<BR><P>")
doc.append("File <b><i>%s</i></b> (version no. %i) successfully uploaded.<P>" 
       % (form['uploadedfile'].filename, version))


doc.append(foot % today)
doc.write()
