#!/usr/bin/env python

# $Id: passwd.py 83 2011-09-21 13:25:16Z kkumer $ 

"""
Functions for encrypting and decrypting password.
"""

import sys, base64

from Crypto.Cipher import DES
ciph = DES.new(cfg['UID_PASSWD'])   
# must have 8 bytes length, should be set in config.py

## Functions for treating URL-password
def checkpwd(form):
    """Checks whether form has key 'pwd' and whether it is encoding of
       some integer.
       checkpwd(<cgi.Fieldstorage instance>) -> integer"""
    # Error message:
    contact = '<P>Contact administrator (<A HREF="mailto:' + cfg['ADMIN'] +\
                '">' + cfg['ADMIN'] + """</A>) and send him exact address
                 of the page you tried to access."""
    if form.has_key('pwd'): 
        pwd = form['pwd'].value
    else: # no password at all
        print "Nonexistent page!" + contact
        sys.exit(1)

    try:
        uid = int(ciph.decrypt(base64.urlsafe_b64decode(pwd[:-3])).strip())
    except ValueError: # pwd is wrong
        print "Nonexistent page or wrong password!" + contact
        sys.exit(1)
    
    return uid

def makepwd(uid):
    """Returns "encrypted" uid, suitable for URL query strings.
       makepwd(integer) -> string"""
    try:
        # We need to put 'end' to fool Outlook who would ignore '='!
        pwd = base64.urlsafe_b64encode(ciph.encrypt('%8i' % uid))+'end'
    except ValueError:
        print "UID %s is not an integer less than 1e8!" % uid
        sys.exit(1)
    return pwd
